<template>
    <el-dialog title="选择商品" :visible.sync="dialogVisible" @open="resetHandle()">
        <el-form :model="searhForm" inline>
            <el-form-item>
                <el-input v-model="searhForm.name" placeholder="商品名称"></el-input>
            </el-form-item>
            <el-form-item>
                <el-select v-model="searhForm.category" placeholder="商品分类">
                    <el-option :label="item.name" :value="item.id" v-for="item in categoryList"
                        :key="item.id"></el-option>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button type="primary">查询</el-button>
                <el-button>重置</el-button>
            </el-form-item>
        </el-form>
        <div class="head-container">
            <el-table ref="table" :data="tableData.list" v-loading="tableData.loading">
                <el-table-column type="selection" width="55" align="center"></el-table-column>
                <el-table-column label="商品信息">
                    <template v-slot="scope">
                        <div class="shop_info">
                            <el-image :src="scope.row.coverImg" style="width: 30px;height: 30px;">
                                <div class="img_error" slot="error">
                                    <i class="icon el-icon-document-delete"></i>
                                </div>
                            </el-image>
                            <span>{{ scope.row.name }}</span>
                        </div>
                    </template>
                </el-table-column>
                <el-table-column label="售价">

                    <template v-slot="scope">
                        ￥{{ scope.row.lowPrice }}
                    </template>
                </el-table-column>
                <el-table-column label="销量/库存">

                    <template v-slot="scope">
                        0/0
                    </template>
                </el-table-column>
                <el-table-column label="分类" prop="categoryId"></el-table-column>
            </el-table>
        </div>
        <el-pagination :total="tableData.total" :current-page="tableData.page + 1" :page-size="tableData.size"
            @current-change="paginationChange" layout="total, sizes, prev, pager, next, jumper"></el-pagination>
        <span slot="footer" class="dialog-footer">
            <el-button @click="dialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="confirmHandle">确 定</el-button>
        </span>
    </el-dialog>
</template>

<script>
import { tbShopCategoryGet, tbProduct } from "@/api/shop";
export default {
    data() {
        return {
            dialogVisible: false,
            searhForm: {
                name: '',
                category: ''
            },
            categoryList: [],
            tableData: {
                page: 0,
                size: 10,
                total: 0,
                loading: false,
                list: []
            },
            goods: []
        }
    },
    methods: {
        // 确定选商品
        confirmHandle() {
            let res = this.$refs.table.selection
            this.$emit('success', res)
            this.close()
        },
        // 重置查询
        resetHandle() {
            this.searhForm.name = ''
            this.searhForm.category = ''
            this.tableData.page = 0
            this.tableData.list = []
            this.getTableData()
        },
        // 分页回调
        paginationChange(e) {
            this.tableData.page = e
            this.getTableData()
        },
        // 商品列表
        async getTableData() {
            this.tableData.loading = true
            try {
                const res = await tbProduct({
                    page: this.tableData.page,
                    size: this.tableData.size,
                    shopId: localStorage.getItem('shopId'),
                    sort: 'id',
                })
                this.tableData.loading = false
                this.tableData.list = res.content
                this.tableData.total = res.totalElements

                if (this.goods.length) {
                    this.$nextTick(() => {
                        this.selection()
                    })
                }
            } catch (error) {
                console.log(error)
            }
        },
        // 商品分类
        async tbShopCategoryGet() {
            try {
                const res = await tbShopCategoryGet({
                    page: 0,
                    size: 100,
                    sort: 'id',
                    shopId: localStorage.getItem('shopId')
                })
                this.categoryList = res.content
            } catch (error) {
                console.log(error)
            }
        },
        show(goods) {
            this.dialogVisible = true
            if (goods && goods.length) {
                this.goods = goods
            } else {
                this.goods = []
            }
            this.resetHandle()
            this.getTableData()
        },
        close() {
            this.dialogVisible = false
        },
        selection() {
            this.goods.forEach(row => {
                this.tableData.list.forEach((item, index) => {
                    if (row.id == item.id) {
                        this.$refs.table.toggleRowSelection(this.tableData.list[index]);
                    }
                })
            });
        }
    }
}
</script>

<style scoped lang="scss">
.shop_info {
    display: flex;
    align-items: center;

    span {
        margin-left: 10px;
    }
}
</style>